Attribute VB_Name = "HornerIEC_CopyPaste"
Option Explicit

Sub PasteFromCscape()
Attribute PasteFromIEC.VB_ProcData.VB_Invoke_Func = "V\n14"
'
' PasteIEC Macro
'

'
On Error GoTo Format

    ActiveWindow.FreezePanes = False
    Cells.Select
    Selection.ClearContents
    Range("A1").Select
    ActiveSheet.Paste
    Selection.TextToColumns Destination:=Range("A1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=False, _
        Semicolon:=True, Comma:=False, Space:=False, Other:=False
        'FieldInfo _
        :=Array(Array(1, 2), Array(2, 1), Array(3, 1), Array(4, 1), Array(5, 1), Array(6, 1), _
        Array(7, 1), Array(8, 1), Array(9, 1), Array(10, 1), Array(11, 1), Array(12, 1)), _
        TrailingMinusNumbers:=True
Format:
    Rows("1:1").Select
    Selection.Font.Bold = True
    With ActiveWindow
        .SplitColumn = 0
        .SplitRow = 1
    End With
    Columns("A:L").EntireColumn.AutoFit
    Columns("A").ColumnWidth = Columns("A").ColumnWidth + 5
    Columns("G").ColumnWidth = 8
    Columns("H").ColumnWidth = Columns("H").ColumnWidth + 2
    Columns("I").ColumnWidth = Columns("I").ColumnWidth + 5
    Columns("L").ColumnWidth = Columns("L").ColumnWidth + 5
    ActiveWindow.FreezePanes = True
    Range("C:C,J:J,K:K,M:M").Select
    Range("K1").Activate
    Selection.EntireColumn.Hidden = True

    Range("A1").Select
End Sub
 
Sub ExportToCscape()
Attribute ExportToIEC.VB_ProcData.VB_Invoke_Func = "C\n14"
' Dimension all variables.
Dim CopyData As String
Dim FileNum As Integer
Dim ColumnCount As Long
Dim RowCount As Long
Dim fsT As Object
Dim Cols As Long
Dim Rows As Long
Dim WhichCol As Long

On Error GoTo MeHaveError

Set fsT = CreateObject("ADODB.Stream")
fsT.Type = 2 'Specify stream type - we want To save text/string data.
fsT.Charset = "utf-8" 'Specify charset For the source text data.
fsT.Open 'Open the stream And write binary data To the object
' Prompt user for destination file name.
'CopyData = InputBox("Enter the destination filename" & Chr(10) & "(with complete path):", "Quote-Comma Exporter")
' Obtain next free file handle number.
' FileNum = FreeFile()
' Turn error checking off.

CopyTextToClipboard ("")

Rows = Selection.Rows.Count
Cols = Selection.Columns.Count

WhichCol = ActiveCell.Column

If Rows > 1 And Cols = 1 And WhichCol = 1 Then
    Selection.Resize(Selection.Rows.Count, 12).Select
    'Range(Selection, Selection.End(xlToRight)).Select
ElseIf Cols < 12 Then
    Range("A1").Select
    ActiveCell.CurrentRegion.Select
ElseIf Cols > 12 Then
    Selection.Resize(Selection.Rows.Count, 12).Select
End If

'On Error Resume Next

Rows = Selection.Rows.Count
Cols = Selection.Columns.Count

' If an error occurs report it and end.
If Err <> 0 Then
    MsgBox "Cannot open filename " & CopyData
    End
End If

' Turn error checking on.
On Error GoTo 0
' Loop for each row in selection.
For RowCount = 1 To Rows
    ' Loop for each column in selection.
    For ColumnCount = 1 To Cols
        ' Write current cell's text to file with quotation marks.
        CopyData = CopyData & """" & Selection.Cells(RowCount, ColumnCount).Text & """"
        
        '''''fsT.WriteText CopyData
        ' Check if cell is in last column.
        If ColumnCount = Cols Then
            ' If so, then write a blank line.
            CopyData = CopyData & vbNewLine
        
        '''''fsT.WriteText vbNewLine
        Else
            ' Otherwise, write a comma.
            CopyData = CopyData & ";"
        End If
        ' Start next iteration of ColumnCount loop.
    Next ColumnCount
    ' Start next iteration of RowCount loop.
Next RowCount

CopyTextToClipboard (CopyData)

GoTo TheEnd

MeHaveError:
MsgBox (Err.Description)

TheEnd:

' Close destination file.
'CopyData = fsT.readtext
'CopyTextToClipboard (CopyData)
'fsT.SaveToFile CopyData, 2
End Sub


Sub CopyTextToClipboard(ByVal inText As String)
  Dim objClipboard As Object
  Set objClipboard = CreateObject("new:{1C3B4210-F441-11CE-B9EA-00AA006B1A69}")
 
  objClipboard.SetText inText
  objClipboard.PutInClipboard
 
  Set objClipboard = Nothing
End Sub
   
Function GetTextFromClipboard() As String
  Dim objClipboard As Object
  Set objClipboard = CreateObject("new:{1C3B4210-F441-11CE-B9EA-00AA006B1A69}")
 
  objClipboard.GetFromClipboard
  GetTextFromClipboard = objClipboard.GetText
 
  Set objClipboard = Nothing
End Function

